package org.processmining.divideandconquer.models;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.framework.util.HTMLToString;

public class Contest2016Report implements HTMLToString {

	private String trainingLogName;
	private String testLogName;
	private Map<String, Double> fitting;
	private Map<String, Double> nonFitting;
	private long time;
	
	public Contest2016Report() {
		setTrainingLogName("Train");
		setTestLogName("Test");
		setFitting(new HashMap<String, Double>());
		setNonFitting(new HashMap<String, Double>());
		setTime(0);
	}

	public String getTrainingLogName() {
		return trainingLogName;
	}

	public void setTrainingLogName(String trainingLogName) {
		this.trainingLogName = trainingLogName;
	}

	public String getTestLogName() {
		return testLogName;
	}

	public void setTestLogName(String testLogName) {
		this.testLogName = testLogName;
	}

	public Map<String, Double> getFitting() {
		return fitting;
	}

	public void setFitting(Map<String, Double> fitting) {
		this.fitting = fitting;
	}

	public Map<String, Double> getNonFitting() {
		return nonFitting;
	}

	public void setNonFitting(Map<String, Double> nonFitting) {
		this.nonFitting = nonFitting;
	}

	public String toHTMLString(boolean includeHTMLTags) {
		// TODO Auto-generated method stub
		StringBuffer buf = new StringBuffer();
		buf.append("<h1>DrFurby Classification took " + getTime() + " ms</h1>");
		buf.append("<h2>Training Log: " + getTrainingLogName() + "</h2>");
		buf.append("<h2>Test Log: " + getTestLogName() + "</h2>");
		buf.append("<h2>Positive Traces: " + getFitting().size() + "</h2>");
		buf.append("<table><tr><th>Trace</th></tr>");
		List<String> keys = new ArrayList<String>(getFitting().keySet());
		Collections.sort(keys);
		for (String key : keys) {
			buf.append("<tr><td>" + key + "</td></tr>");
		}
		buf.append("</table>");
		buf.append("<h2>Negative Traces: " + getNonFitting().size() + "</h2>");
		buf.append("<table><tr><th>Trace</th><th>Replay costs</th></tr>");
		keys = new ArrayList<String>(getNonFitting().keySet());
		Collections.sort(keys);
		for (String key : keys) {
			buf.append("<tr><td>" + key + "</td><td>" + getNonFitting().get(key) + "</td></tr>");
		}
		buf.append("</table>");
		return buf.toString();
	}

	public long getTime() {
		return time;
	}

	public void setTime(long time) {
		this.time = time;
	}
}
