package org.processmining.divideandconquer.plugins;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.divideandconquer.algorithms.Contest2016Algorithm;
import org.processmining.divideandconquer.models.Contest2016Report;
import org.processmining.divideandconquer.parameters.Contest2016Parameters;
import org.processmining.framework.abstractplugins.ImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.log.OpenLogFilePlugin;

// HV: Plug-in commented out, replaced by plug-in in DrFurbyPlugin class.

//@Plugin(name = "DrFurby Classifier", parameterLabels = { "Training Log", "Test Log", "Parameters" }, returnLabels = { "DrFurby Classification" }, returnTypes = {
//		Contest2016Report.class }, help = Contest2016Help.TEXT)
public class Contest2016Plugin extends Contest2016Algorithm {

	private static ImportPlugin logImporter = new OpenLogFilePlugin();

//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
//	@PluginVariant(variantLabel = "Default", requiredParameterLabels = { 2 })
	public static Contest2016Report run(final PluginContext context, Contest2016Parameters parameters) {
		try {
			System.out.println("Model: " + parameters.getModel());
			System.out.println("Importing model_" + parameters.getModel() + ".xes");
			/*
			 * Import the training log.
			 */
			XLog trainingLog = (XLog) logImporter.importFile(context,
					"D:\\Data Sets\\Contest 2016\\training_log_" + parameters.getModel() + ".xes");
			/*
			 * Import the test log.
			 */
			XLog testLog = (XLog) logImporter.importFile(context,
					"D:\\Data Sets\\Contest 2016\\Test logs april\\test_log_april_" + parameters.getModel() + ".xes");
			/*
			 * Create a new plug in.
			 */
			Contest2016Plugin plugin = new Contest2016Plugin();
			return plugin.apply(context, trainingLog, testLog, parameters);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
//	@PluginVariant(variantLabel = "Default", requiredParameterLabels = { 0, 1 })
	public Contest2016Report run(final UIPluginContext context, final XLog trainingLog, final XLog testLog) {
		return apply(context, trainingLog, testLog, new Contest2016Parameters());
	}
	
}
